在shell脚本中:执行echo shell命令

在shell脚本中,我如何回显所有调用的shell命令并展开任何variables名称? 例如,给出以下行:

ls $DIRNAME 

我想要脚本运行该命令并显示以下内容

 ls /full/path/to/some/dir 

目的是保存所有调用的shell命令及其参数的日志。 也许有更好的方法来产生这样一个日志?

set -xset -o xtrace展开variables并在行之前打印一个+号。

set -vset -o verbose在打印之前不会展开variables。

使用set +xset +vclosures上述设置。

在脚本的第一行中,可以在脚本中稍后将#!/bin/sh -xset -x为相同的效果。

以上也适用于/bin/sh

http://www.faqs.org/docs/abs/HTML/options.html

 $ cat shl #!/bin/bash DIR=/tmp/so ls $DIR $ bash -x shl + DIR=/tmp/so + ls /tmp/so $ 

set -x会给你你想要的。

这里是一个示例shell脚本来演示:

 #!/bin/bash set -x #echo on ls $PWD 

这将扩展所有variables,并在输出命令之前打印完整的命令。

输出:

 + ls /home/user/ file1.txt file2.txt 

你也可以在你的脚本中通过将它们包装在set -xset +x来切换这个行

 #!/bin/bash ... if [[ ! -e $OUT_FILE ]]; then echo "grabbing $URL" set -x curl --fail --noproxy $SERV -s -S $URL -o $OUT_FILE set +x fi 

我使用一个函数来回显然后运行命令

 #!/bin/bash #function to display commands exe() { echo "\$ $@" ; "$@" ; } exe echo hello world 

哪个输出

 $ echo hello world hello world 

编辑:

对于更复杂的命令pipe道等,你可以使用eval:

 #!/bin/bash #function to display commands exe() { echo "\$ ${@/eval/}" ; "$@" ; } exe eval "echo 'Hello World' | cut -d ' ' -f1" 

哪个输出

 $ echo 'Hello World' | cut -d ' ' -f1 Hello 

shuckc回答select线路的回答有一些缺点:你最终还会回应下面的set +x命令,你失去了用$?testing退出码的能力$? 因为它会被set +x覆盖。

另一种select是在子shell中运行命令:

 echo "getting URL..." ( set -x ; curl -s --fail $URL -o $OUTFILE ) if [ $? -eq 0 ] ; then echo "curl failed" exit 1 fi 

这会给你如下的输出:

 getting URL... + curl -s --fail http://example.com/missing -o /tmp/example curl failed 

不过,这会导致为命令创build新的子shell的开销。

另一种select是将“-x”放在脚本的顶部而不是在命令行上:

 $ cat ./server #!/bin/bash -x ssh user@server $ ./server + ssh user@server user@server's password: ^C $ 

(没有足够的代表评论select的答案。)

在命令行上input“bash -x”,然后inputbash脚本的名称。 例如,要执行foo.sh,input:

 bash -x foo.sh 

根据TLDP的Bash初学者指南:第2章。编写和debugging脚本

2.3.1。 debugging整个脚本

 $ bash -x script1.sh 

现在在SourceForge上提供了一个完整的Bashdebugging器。 这些debuggingfunction在大多数现代版本的Bash中都可用,从3.x开始。

2.3.2。 debugging脚本的部分

 set -x # activate debugging from here w set +x # stop debugging from here 

表2-1。 设置debugging选项的概述

 Short | Long notation | Result -------+---------------+-------------------------------------------------------------- set -f | set -o noglob | Disable file name generation using metacharacters (globbing). set -v | set -o verbose| Prints shell input lines as they are read. set -x | set -o xtrace | Print command traces before executing command. 

或者,可以在脚本本身中指定这些模式,方法是在第一行shell声明中添加所需的选项。 选项可以结合使用,与UNIX命令通常一样:

 #!/bin/bash -xv 

对于zsh回声

  setopt VERBOSE 

并进行debugging

  setopt XTRACE 

上面有人发帖:

 #!/bin/bash #function to display commands exe() { echo "\$ $@" ; "$@" ; } 

这看起来很有希望,但我不能为了我的生活找出它的作用。 我已经在man bash页面search了“\ $”和“$ @”,并且找不到任何东西

我明白正在创build一个名为“exec()”的函数。 我明白花括号标记了函数的开始和结束。 我认为我明白,分号标志着多行命令之间的“硬回归”,所以'{echo'\ $ $ @“; “$ @”; 本质上:

 { echo "\$ $@" "$@" } 

任何人都可以给我一个简短的解释,或者在哪里可以find这个信息,因为显然我的google-fu正在让我失望?

(没有意义在一个旧的线程上开始一个新的问题,我的目标是将输出重新路由到一个文件,“set -x; [commands]; set + x”方法对我来说工作得很好,但是我可以'不知道如何将结果回显到一个文件而不是屏幕上,所以我想了解另外一种方法,希望我能够很好地理解redirect/pipe道/ tee /等等。

谢谢!

后期编辑:

有一些修补,我相信我明白了。 这是我需要的等价代码:

 SCRIPT_LOG="\home\buddy\logfile.txt" exe () { params="$@" # Put all of the command-line into "params" printf "%s\t$params" "$(date)" >> "$SCRIPT_LOG" # Print the command to the log file $params # Execute the command } exe rm -rf /Library/LaunchAgents/offendingfile exe rm -rf /Library/LaunchAgents/secondoffendingfile 

logfile.txt中的结果如下所示:

 Tue Jun 7 16:59:57 CDT 2016 rm -rf /Library/LaunchAgents/offendingfile Tue Jun 7 16:59:57 CDT 2016 rm -rf /Library/LaunchAgents/secondoffendingfile 

正是我所需要的。 谢谢!

您可以使用-x选项在debugging模式下执行 bash脚本。
这将回应所有的命令。

 bash -x example_script.sh # Console output + cd /home/user + mv text.txt mytext.txt 

您还可以在脚本中保存-x选项 。 只需在shebang中指定-x选项。

 ######## example_script.sh ################### #!/bin/bash -x cd /home/user mv text.txt mytext.txt ############################################## ./example_script.sh # Console output + cd /home/user + mv text.txt mytext.txt 

对于cshtcsh ,您可以set verboseset echo (或者甚至可以同时设置,但大部分时间可能会导致重复)。

verbose选项几乎打印出你input的确切的shellexpression式。

echo选项更多地指示将通过产卵执行什么。


http://www.tcsh.org/tcsh.html/Special_shell_variables.html#verbose

http://www.tcsh.org/tcsh.html/Special_shell_variables.html#echo


Special shell variables

verbose If set, causes the words of each command to be printed, after history substitution (if any). Set by the -v command line option.

echo If set, each command with its arguments is echoed just before it is executed. For non-builtin commands all expansions occur before echoing. Builtin commands are echoed before command and filename substitution, because these substitutions are then done selectively. Set by the -x command line option.

为了允许复合命令被回显,我使用eval和Soth的exe函数来回显然后运行命令。 这对pipe道命令非常有用,否则pipe道命令将只显示任何内容或仅显示pipe道命令的初始部分。

没有评估:

 exe() { echo "\$ $@" ; "$@" ; } exe ls -F | grep *.txt 

输出:

 $ file.txt 

用eval:

 exe() { echo "\$ $@" ; "$@" ; } exe eval 'ls -F | grep *.txt' 

哪个输出

 $ exe eval 'ls -F | grep *.txt' file.txt 
 $ cat exampleScript.sh #!/bin/bash name="karthik"; echo $name; bash -x exampleScript.sh 

输出如下:

在这里输入图像说明